"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.findCollaboratorsByAppNameAndUid = exports.Collaborators = void 0;
const sequelize_1 = require("sequelize");
const connections_1 = require("../core/utils/connections");
exports.Collaborators = connections_1.sequelize.define('Collaborators', {
    id: {
        type: sequelize_1.DataTypes.BIGINT({ length: 20 }),
        allowNull: false,
        autoIncrement: true,
        primaryKey: true,
    },
    appid: sequelize_1.DataTypes.INTEGER({ length: 10 }),
    uid: sequelize_1.DataTypes.BIGINT({ length: 20 }),
    roles: sequelize_1.DataTypes.STRING,
    created_at: sequelize_1.DataTypes.DATE,
    updated_at: sequelize_1.DataTypes.DATE,
}, {
    tableName: 'collaborators',
    underscored: true,
    paranoid: true,
});
async function findCollaboratorsByAppNameAndUid(uid, appName) {
    const sql = 'SELECT b.* FROM `apps` as a left join `collaborators` as b  on (a.id = b.appid) where a.name= :appName and b.uid = :uid and a.`deleted_at` IS NULL and b.`deleted_at` IS NULL limit 0,1';
    const data = await connections_1.sequelize.query(sql, {
        replacements: { appName, uid },
        model: exports.Collaborators,
    });
    return data.pop();
}
exports.findCollaboratorsByAppNameAndUid = findCollaboratorsByAppNameAndUid;
