"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Packages = void 0;
const sequelize_1 = require("sequelize");
const connections_1 = require("../core/utils/connections");
exports.Packages = connections_1.sequelize.define('Packages', {
    id: {
        type: sequelize_1.DataTypes.INTEGER({ length: 10 }),
        allowNull: false,
        autoIncrement: true,
        primaryKey: true,
    },
    deployment_version_id: sequelize_1.DataTypes.INTEGER({ length: 10 }),
    deployment_id: sequelize_1.DataTypes.INTEGER({ length: 10 }),
    description: sequelize_1.DataTypes.STRING,
    package_hash: sequelize_1.DataTypes.STRING,
    blob_url: sequelize_1.DataTypes.STRING,
    size: sequelize_1.DataTypes.INTEGER({ length: 10 }),
    manifest_blob_url: sequelize_1.DataTypes.STRING,
    release_method: sequelize_1.DataTypes.STRING,
    label: sequelize_1.DataTypes.STRING,
    original_label: sequelize_1.DataTypes.STRING,
    original_deployment: sequelize_1.DataTypes.STRING,
    released_by: sequelize_1.DataTypes.BIGINT({ length: 20 }),
    is_mandatory: sequelize_1.DataTypes.INTEGER({ length: 3 }),
    is_disabled: sequelize_1.DataTypes.INTEGER({ length: 3 }),
    rollout: sequelize_1.DataTypes.INTEGER({ length: 3 }),
    created_at: sequelize_1.DataTypes.DATE,
    updated_at: sequelize_1.DataTypes.DATE,
}, {
    tableName: 'packages',
    underscored: true,
    paranoid: true,
});
